#include <aversive.h>
#include <aversive/queue.h>

#include <stdint.h>

#include <uart.h>

#include <scheduler.h>
#include <clock_time.h>
#include <parse.h>
#include <rdline.h>
#include <timer.h>

#include "xbee_proto.h"
#include "callout.h"
#include "rc_proto.h"
#include "main.h"

struct power_levels {
	int ttl;
	int power_db;
};

struct power_levels power_levels[MAX_POWER_LEVEL];

static int set_power_level(void *frame, unsigned len, void *arg)
{
	struct xbee_atresp_hdr *atresp = (struct xbee_atresp_hdr *)frame;
	int level = (intptr_t)arg;
	uint8_t db;

	/* XXX check if this test is correct */
	if (len < sizeof(struct xbee_atresp_hdr) + sizeof(uint8_t))
		return -1;

	db = atresp->data[0];
	power_levels[level].power_db = db;
	power_levels[level].ttl = 2;
	return 0;
}

void rc_proto_rx_range(int power_level)
{
	xbeeapp_send_atcmd("DB", NULL, 0, 0,
			   set_power_level, (void *)(intptr_t)power_level);

}


